/****************************************************************************
Program    : Getline
Version    : 1.00.A
Programmer : Binny V Abraham
E-Mail     : binnyva@rediffmail.com
Website    : http://www.geocities.com/binnyva
C++ Special: http://www.geocities.com/binnyva/code/cpp/

Use
---
Displays the specifed line of a specifed file(specifed at the command line).
Kind of like the 'head' and 'tail' command in UNIX.

Special
-------
This is a part of the Batch Toolkit by Binny's softwares. To find out more,
go to http://www.geocities.com/binnyva. Programs in Batch Toolkit -
Becho, Getline, Message, Select, Tnd. Made for use in Batch files.

License
-------
You can use this program, modify it, distribute it, make money from it or
any thing by it. But please give credit where credit is due. Mention my name
or my site in the credits.

Disclamer
---------
If any thing happens to your computer by using my program, it is NOT my porblem. 
It will be your own fault.

If you want more info, contact me at binnyva@rediffmail.com.
****************************************************************************/
#include <string.h>
#include <process.h>
#include <fstream.h>
#include <iostream.h>
//#include <conio.h>

//Global variables
char version[]="1.00.A";

//Help Menu...
void help()
 {
 cout<<"Getline "<<version<<"     By      Binny's Softwares\n\n"
     <<"http://www.geocities.com/binnyva\nE-Mail : binnyva@rediffmail.com\n\n"
     <<"Usage : Getline <FileName> [OPTIONS] <StartLineNumber> [ - ] [<EndLineNumber>]\n\n";
 cout<<"This command will show the contents of a file from <StartLineNumber> to <EndLineNumber> "
     <<"which can be specifed at command line. If <EndLineNumber> is ommited, only line number <StartLineNumber> is "
     <<"is shown. If <EndLineNumber> is end or 0 or greater than the last line number, everything "
     <<"from <StartLineNumber> to end of file is shown.\n"
     <<"Example : getline autoexec.bat 2 - end\n\n";
 cout<<"Command Line Options\n---------------\n"
     <<"\t-v \t\t - Verbose Mode\n"
     <<"\t-noerror \t - Will not display any error.\n"
     <<"\t-? OR -h \t - Display the help screen.\n";

 exit(0);
 }

//Basically the pow() funtion. I did not want to include a header file for
//	just 1 function
int power(int base,int power)
 {
 if(power==0) base=1;
 for(int i=1;i<power;i++)
  {
  cout<<i;
  base=base*base;
  }
 return base;
 }

/***************************** IsNum *****************************/
//This funciton will return the value if the argument is a number
int isNum(char arg[25])
 {
 int len=strlen(arg);
 //If the number has more than 5 digits, exit
 if(len>5) return -1;

 int flag=0,number=0,no=0,digit=0;
 for(int i=len-1;i>=0;i--)
  {
  switch (arg[i])
   {
   case '0': no=0;break;
   case '1': no=1;break;
   case '2': no=2;break;
   case '3': no=3;break;
   case '4': no=4;break;
   case '5': no=5;break;
   case '6': no=6;break;
   case '7': no=7;break;
   case '8': no=8;break;
   case '9': no=9;break;
   default:flag++;break;
   }
  number=number+(power(10,digit)*no);
  digit++;
  }

 if(flag) number=-1;
 return number;
 }

/*****************************Function Main*****************************/
void main(int argc,char *argv[])
 {
 //clrscr();

 int current_line=1,start=1,end=-1;
 int flag=0,temp=0;;
 char ch='a';
 char file[15]="";

 //Configurations
 int verbose=0,showerror=1;

 //Getting the Command Line Options (CLO)
 for(int i=1;i<argc;i++)
  {
  if(!strcmpi(argv[i],"-v")) verbose=1;
  else if(!strcmpi(argv[i],"-noerror")) showerror=0;
  else if(!strcmpi(argv[i],"-h")||!strcmpi(argv[i],"--help")||!strcmpi(argv[i],"/?")||!strcmpi(argv[i],"-?"))
   { help(); }
  else
   {
   //Getting the starting and ending line numbers.
   temp=isNum(argv[i]);
   //Line No
   if(i==2)
    {
    //Starting
    if(temp>0) start=temp;
    else
     {
     if(showerror) cout<<"Syntax error! The second argument should be a valid line number.\n";
     exit(1);
     }
    }
   else if(i<5)
    {
    //Ending
    if(temp>0) end=temp;
    else if(!strcmp(argv[i],"end")) end=0;
    }
   }
  }

 //If arguments are not given, show help and exit.
 if(argc<2) help();

 //Get the filename
 strcpy(file,argv[1]);
 ifstream in(file);
 //If no such file exists,
 if(!in)
  {
  if(showerror) cout<<"\""<<file<<"\" not found. Please specify an existing file as the first argument.";
  exit(1);
  }

 //Check for errors
 if(end<start && end!=0 && end!=-1)
  {
  if(showerror) cout<<"Syntax error! The firt line number("<<start<<") should not be greater than the second("<<end<<").\n";
  exit(1);
  }

 //Show info
 if(verbose)
  {
  cout<<"Printing file \""<<file<<"\" - line "<<start;
  if(end>0) cout<<" to "<<end<<".\n";
  else if(end==0) cout<<" to end.\n";
  else cout<<".\n";
  }

 //Going thru the file
 while(in)
  {
  in.get(ch);

  //If the starting line is reached, enable 'flag'
  if(current_line==start) flag++;
  //If ending line is not specifed, or if the ending line is reached,
  //	disable 'flag'
  if(current_line==end && flag && (current_line!=start))
   {
   flag=0;
   break;//Get Out - don't go to the end of the file.
   }

  //As long as flag is enabled, output content
  if(flag)
   {
   cout<<ch;
   //If the line is over, and just this line needs to be displayed,
   //	disable 'flag'
   if(ch=='\n' && end==-1) flag=0;
   }

  if(ch=='\n') current_line++; //If '\n' is encounted, increment 'current_line'
  }
 in.close();

 // getch();
 }