/****************************************************************************
Program    : tnd - Time 'n Date
Version    : 2.00.A
Programmer : Binny V Abraham
E-Mail     : binnyva@rediffmail.com
Website    : http://www.geocities.com/binnyva
C++ Special: http://www.geocities.com/binnyva/code/cpp/

Use
---
Prints the time and the date in the format specified in the
command Line

Special
-------
This is a part of the Batch Toolkit by Binny's softwares. To find out more,
go to http://www.geocities.com/binnyva. Programs in Batch Toolkit -
Becho, Getline, Message, Select, Tnd. Made for use in Batch files.

License
-------
You can use this program, modify it, distribute it, make money from it or
any thing by it. But please give credit where credit is due. Mention my name
or my site in the credits.

Disclamer
---------
If any thing happens to your computer by using my program, it is NOT my porblem. 
It will be your own fault.

If you want more info, contact me at binnyva@rediffmail.com.
****************************************************************************/
#include <string.h>
#include <iostream.h>
#include <dos.h>
#include <time.h>

char digit2number(int digit)
 {
 char number;
 if(digit==1) number='1';
 else if(digit==2) number='2';
 else if(digit==3) number='3';
 else if(digit==4) number='4';
 else if(digit==5) number='5';
 else if(digit==6) number='6';
 else if(digit==7) number='7';
 else if(digit==8) number='8';
 else if(digit==9) number='9';
 return number;
 }

void number2string(int number,char *string,int zero)
 {
 if(number<10&&zero)
  {
  string[0]='0';
  string[1]=digit2number(number);
  string[2]='\0';
  }
 else if(number>9)
  {
  string[0]=digit2number(number/10);
  string[1]=digit2number(number%10);
  string[2]='\0';
  }
 else
  {
  string[0]=digit2number(number);
  string[1]='\0';
  }
 }

void main()
 {
 // clrscr();
 char version[] = "2.00.A";
 int zero=0;
 int debug=0;
 char ampm[3],mon[10],week[10],c;

 //Get the time
 time_t timer;
 struct tm *tblock;
 /* gets time of day */
 timer = time(NULL);
 /* converts date/time to a structure */
 tblock = localtime(&timer);
 struct tm t = *tblock;

 int hour_no = t.tm_hour;
 int min_no = t.tm_min;
 int wday = t.tm_wday;
 int day_no = t.tm_mday;
 int mon_no = t.tm_mon + 1;
 int year = t.tm_year + 1900;
 int hours24 = t.tm_hour;

 //Find whether the time is AM or PM
 if (hour_no>=12)
  {
  strcpy(ampm,"PM");
  hour_no=hour_no-12;
  if(hour_no==0) hour_no=12;
  }
 else
  {
  strcpy(ampm,"AM");
  hour_no=hour_no;
  if(hour_no==0) hour_no=12;
  }

 for(int i=1;i<_argc;i++)
  {
  //Turn on Debug
  if(!strcmpi(_argv[i],"-debug"))
   {
   cout<<"Debug Info Enabled\n";
   cout<<"Command Line Options:\n";
   for(int i=1;i<_argc;i++) cout<<_argv[i]<<" ";
   cout<<"\n";
   debug=1;
   }
  //If the zero's must be shown. For eg. if the date is 1-12, it will become 01-12
  else if(!strcmpi(_argv[i],"-0"))
   {
   if(debug) cout<<"Zero correction Enabled\n";
   zero=1;
   }
  }
 //Make all the numbers to strings
 char day[3],month[3],day0[3],month0[3];
 char hour[3],min[3],hour0[3],min0[3];
 number2string(day_no,day,zero); //Day Pharsing
 number2string(mon_no,month,zero); //Month Pharsing
 number2string(day_no,day0,1); //Day Pharsing with Zero Correction
 number2string(mon_no,month0,1); //Month Pharsing with Zero Correction
 number2string(hour_no,hour,zero); //Hour Pharsing
 number2string(min_no,min,zero); //Minutes Pharsing
 number2string(hour_no,hour0,1); //Hour Pharsing with Zero Correction
 number2string(min_no,min0,1); //Minutes Pharsing with Zero Correction

 //Find the name of the month and week
 char *weekdays[] = {"Sunday", "Monday", "Tuesday", "Wednesday","Thursday", "Friday", "Saturday", "Unknown"};
 char *weekdays_small[] = {"Sun", "Mon", "Tue", "Wed","Thu", "Fri", "Sat", "Unknown"};
 char *months[] = {"January","February","March","April","May","June","July","August","September","October","November","December","Unknown"};
 char *months_small[] = {"Jan","Feb","Mar","Apr","May","June","July","Aug","Sept","Oct","Nov","Dec","Unknown"};

 strcpy(mon,months[mon_no-1]);
 strcpy(week,weekdays[wday]);

 //Basic Time format
 if(!strcmpi(_argv[1],"-t")) cout<<hour<<":"<<min<<" "<<ampm;

 //Display day in short Format - 31-12-1999
 else if(!strcmpi(_argv[1],"-d")) cout<<day<<"-"<<month<<"-"<<year;
 //Display day in Long Format - 1st January 2000
 else if(!strcmpi(_argv[1],"-l"))
  {
  cout<<day;//The day
  //Add the needed addition. 1st 2nd 3rd 4th etc.
  if(day_no==1||day_no==21||day_no==31) cout<<"st ";
  else if(day_no==2||day_no==22) cout<<"nd ";
  else if(day_no==3||day_no==23) cout<<"rd ";
  else cout<<"th ";
  cout<<mon<<" "<<year;// Month name and Year
  }
 //Day and Month - 31-12
 else if(!strcmpi(_argv[1],"-dm")) cout<<day<<"-"<<month;
 //Month and day - 12-31
 else if(!strcmpi(_argv[1],"-md")) cout<<month<<"-"<<day;

 //Extended Display Format
 else if(!strcmpi(_argv[1],"-x"))
  {
  if(debug) cout<<"Length of II argument("<<_argv[2]<<") is "<<strlen(_argv[2])<<"\n";
  for(int j=0;j<strlen(_argv[2]);j++)
   {
   if(_argv[2][j]=='\\'||_argv[2][j]=='/')
    {
    j++;
    c=_argv[2][j];
		if(debug) cout<<"\n/ encounted at "<<i<<" followed by"<<c<<"\n";
    //Days
    if(c=='d') cout<<day_no; //Day
    else if(c=='D') cout<<day0; //Date with Zero correction
    else if(c=='m') cout<<mon_no;//Month
    else if(c=='M') cout<<month0; //Month with Zero correction
    else if(c=='n') cout<<months_small[mon_no-1]; //Small name of month - Jan, Feb etc.
    else if(c=='N') cout<<mon; //Name of month
    else if(c=='y') cout<<year-2000;//Year - 04
    else if(c=='Y') cout<<year;//Year - 2004
    else if(c=='w') cout<<weekdays_small[wday];//Small name of Weekday
    else if(c=='W') cout<<week;//Small name of Weekday
    //Times
    else if(c=='h') cout<<hour_no;
    else if(c=='H') cout<<hour0;
    else if(c=='2') cout<<hours24; //24 hour clock
    else if(c=='e') cout<<min_no;
    else if(c=='E') cout<<min0;
    else if(c=='-') cout<<"-";
    else if(c=='_') cout<<" ";
    else if(c=='\'') cout<<"\"";
    else if(c=='\\') cout<<"\\";
    else if(c=='/') cout<<"/";
    else if(c=='a') cout<<ampm;//AM\PM
    }
   else cout<<_argv[2][j];
   }
  }
 //Help - Happens when there is -? in the command line
 else if(!strcmpi(_argv[1],"-?")||!strcmpi(_argv[1],"?")||!strcmpi(_argv[1],"/?")||!strcmpi(_argv[1],"\?")||!strcmpi(_argv[1],"-h")||!strcmpi(_argv[1],"-help"))
  {
  cout<<"tnd - Time 'n Date\nBy Binny's Softwares\n"
      <<"http://www.geocites.com/binnyva\nbinnyva@rediffmail.com"
      <<"Version    : "<<version<<"\n\n";
  cout<<"Command Line Options\n--------------------\n"
  <<"-t\tShows Time in \"Hours:Min AM/PM\" Format\n"
  <<"-d\tShows Date in \"D-M-Y\" Format\n"
  <<"-dm\tShows Date in \"D-M\" Format\n"
  <<"-md\tShows Date in \"M-D\" Format\n"
  <<"-l\tDisplay day in Long Format - 1st January 2000.\n"
  <<"-0\tAdd 0 to the number. 1-9-2004 becomes 01-09-2004\n"
  <<"-x\tAllows eXtended formating of date and time.\n"
    <<"\tAfter the '-x' leave a space and type the following\n"
    <<"\t/d\tFor Day\t\t\t/D\tFor zeros in day(1 becomes 01)\n"
    <<"\t/m\tFor Month\t\t/M\tFor month with zeros\n"
    <<"\t/w\tFor small name of Weekday (Mon,Tue, etc.)\n"
    <<"\t/W\tFor name of Weekday (Monday,Tuesday, etc.)\n"
    <<"\t/n\tFor small Name of the month (Jan, Feb, etc.)\n"
    <<"\t/N\tFor Name of the month (January, February, etc.)\n"
    <<"\t/y\tFor Year\t\t/Y\tFor 4 charector year(2004)\n"
    <<"\t/h\tFor Hour\t\t/H\tFor hours with zeros\n"
    <<"\t/2\tFor hours in 24 hour clock\n"
    <<"\t/e\tFor minutE\t\t/E\tFor minutEs with zeros\n"
    <<"\t/a\tFor AM/PM\n"
    <<"\t/-\tFor putting the charector '-'\n"
    <<"\t/_\tFor putting a space ' '\n"
    <<"\t/'\tFor putting a quotes charector '\"'\n";
  }
 //Default. Happens when the program is executed without any command line arguments
 else cout<<"Date: "<<day<<"-"<<month<<"-"<<year<<" "<<week<<"\n"
	  <<"Time: "<<hour<<":"<<min<<" "<<ampm<<"\n";
 }

/**************************************************************************
TO DO
=====
BUG : Once 2:50 AM was reported as 2:5 AM. The zero was missing.

History
=======
V 2.00.A
--------
First Major Public Release
***************************************************************************/